## mdk4 0~git20181004

=== Makefile ===
MDK_ROOT = ..
include $(MDK_ROOT)/common.mak

CFLAGS		+= -g -O3 -Wall -Wextra 
LINKFLAGS	= -lpthread -lpcap $(LDFLAGS)

SBINDIR		= $(PREFIX)/sbin
MANDIR		= $(PREFIX)/share/man

OSD		= osdep
LIBS		+= -lm -L$(OSD) -l$(OSD)
LIBOSD		= $(OSD)/lib$(OSD).so

OBJS		= debug.o helpers.o mac_addr.o linkedlist.o greylist.o dumpfile.o packet.o brute.o
OBJS_OSD	= osdep.o channelhopper.o ghosting.o fragmenting.o

ATTACKS		= attacks
OBJ_ATT		= $(shell ls attacks/*.h | sed s/"\.h"/"\.o"/g)

all: osd mdk4 $(OBJ_ATT) att

att:
	$(MAKE) -C $(ATTACKS)

osd:
	$(MAKE) -C $(OSD)

$(LIBOSD):
	$(MAKE) -C $(OSD)

$(OBJ_ATT):
	$(MAKE) -C $(ATTACKS)

mdk4: mdk4.c $(OSD)/libosdep.a $(OBJS) $(OBJS_OSD) $(OBJ_ATT)
	$(MAKE) -C $(ATTACKS)
	$(CC) $(CFLAGS) $(^) -o $(@) $(LIBS) $(LINKFLAGS)

test: test.c $(OBJS)
	$(CC) $(CFLAGS) $(^) -o $(@) $(LINKFLAGS)
	mv $(@) ..

install: mdk4
	install -D -m 0755 $^ $(SBINDIR)/$^
	$(MAKE) -C $(ATTACKS) install
	$(MAKE) -C $(OSD) install

.PHONY : clean
clean:
	rm -f mdk4
	rm -f $(OBJS) $(OBJS_OSD)
	rm -f ../test *.o
	$(MAKE) -C $(OSD) clean
	$(MAKE) -C $(ATTACKS) clean

distclean: clean

=== debian/changelog ===
mdk4 (0~git20181004-1) unstable; urgency=medium

  * Initial release on Debian (closes: #910338)
  * New upstream release 0~git20181004.
  * Bump Standards-Version to 4.2.1
  * Move maintenance to Security Tools Packaging Team
  * d/copyright: update file
  * d/mdk4.docs: don't ship old docs from mdk3 (change later
    if docs get updated)
  * d/patches: Forward all patches to upstream
  * wrap-and-sort -a

 -- Samuel Henrique <samueloph@debian.org>  Fri, 05 Oct 2018 03:37:10 -0300

mdk4 (0~git20180705-0kali1) kali-dev; urgency=medium

  * Initial release

 -- Sophie Brun <sophie@freexian.com>  Thu, 05 Jul 2018 09:46:09 +0200

=== debian/control ===
Source: mdk4
Section: net
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: Samuel Henrique <samueloph@debian.org>
Build-Depends: debhelper (>= 11),
               libnl-3-dev,
               libnl-genl-3-dev,
               libpcap-dev,
               pkg-config
Standards-Version: 4.2.1
Homepage: https://github.com/aircrack-ng/mdk4
Vcs-Browser: https://salsa.debian.org/pkg-security-team/mdk4
Vcs-Git: https://salsa.debian.org/pkg-security-team/mdk4.git

Package: mdk4
Architecture: any
Depends: aircrack-ng,
         ${misc:Depends},
         ${shlibs:Depends}
Description: Wireless attack tool for IEEE 802.11 networks
 This package contains a proof-of-concept tool to exploit common IEEE 802.11
 protocol weaknesses.
 .
 MDK4 is a new version of MDK3. MDK4 is a Wi-Fi testing tool from E7mer of
 360PegasusTeam, ASPj of k2wrlz, it uses the osdep library from the aircrack-ng
 project to inject frames on several operating systems.
 .
 IMPORTANT: It is your responsibility to make sure you have permission from the
 network owner before running MDK against it.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ 

override_dh_auto_install:
	# override this: it installs in /usr/local

## mdk4 0~git20181205

=== Makefile ===
--- 
+++ 
@@ -25,7 +25,7 @@
 osd:
 	$(MAKE) -C $(OSD)
 
-$(LIBOSD):
+$(LIBOSD) $(OSD)/libosdep.a:
 	$(MAKE) -C $(OSD)
 
 $(OBJ_ATT):

=== attacks/Makefile ===
CFLAGS		= -g -O3 -Wall -Wextra
LINKFLAGS	= -lpthread

OBJS		= $(shell ls *.h | sed s/"\.h"/"\.o"/g)

all: $(OBJS)

install: $(OBJS)

.PHONY: clean
clean:
	rm -f $(OBJS) *.o

distclean: clean

=== debian/changelog ===
mdk4 (0~git20181205-2) unstable; urgency=medium

  * Bump DH level to 12
  * Bump Standards-Version to 4.3.0
  * d/p/makefile-flags.patch: respect {CPP|LD}FLAGS for hardening

 -- Samuel Henrique <samueloph@debian.org>  Wed, 16 Jan 2019 00:43:53 +0000

mdk4 (0~git20181205-1) unstable; urgency=medium

  * New upstream version 0~git20181205
  * d/copyright: use https
  * d/patches: remove patches applied upstream
  * d/p/fix-makefile-variable.patch: new patch to fix regressions
    introduced on the previous upstream commit
  * d/rules: remove trailing whitespace

 -- Samuel Henrique <samueloph@debian.org>  Wed, 05 Dec 2018 22:47:46 +0000

## mdk4 4.1

=== Makefile ===
DESTDIR		=
PREFIX		= /usr/local
SBINDIR		= $(PREFIX)/sbin
MANDIR		= $(PREFIX)/share/man

SRC		= src


all: clean
	$(MAKE) -C $(SRC)

install: all
	PREFIX:=$(DESTDIR)$(PREFIX) $(MAKE) -C $(SRC) install
	install -D -m 0644 man/mdk4.1 $(DESTDIR)$(MANDIR)/man8/mdk4.1
	gzip -f $(DESTDIR)$(MANDIR)/man8/mdk4.1

.PHONY : clean
clean:
	$(MAKE) -C $(SRC) clean

test:
	$(MAKE) -C $(SRC) test

distclean: clean

=== debian/changelog ===
mdk4 (4.1-1) unstable; urgency=medium

  * New upstream version 4.1
  * d/p/fix-makefile-variable.patch: Remove, applied upstream
  * d/p/makefile-flags.patch: Remove, applied upstream

 -- Samuel Henrique <samueloph@debian.org>  Sat, 20 Apr 2019 17:23:54 +0100

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,12 @@
 Priority: optional
 Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
 Uploaders: Samuel Henrique <samueloph@debian.org>
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper (>= 12),
                libnl-3-dev,
                libnl-genl-3-dev,
                libpcap-dev,
                pkg-config
-Standards-Version: 4.2.1
+Standards-Version: 4.3.0
 Homepage: https://github.com/aircrack-ng/mdk4
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/mdk4
 Vcs-Git: https://salsa.debian.org/pkg-security-team/mdk4.git

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_install:
	# override this: it installs in /usr/local

## mdk4 4.1+git20190904

=== Makefile ===
DESTDIR		= 
PREFIX		= /usr/local
SBINDIR		= $(PREFIX)/sbin
MANDIR		= $(PREFIX)/share/man

SRC		= src


all: clean
	$(MAKE) -C $(SRC)

install: all
	PREFIX=$(DESTDIR)$(PREFIX)
	$(MAKE) -C $(SRC) install
	install -D -m 0644 man/mdk4.1 $(DESTDIR)$(MANDIR)/man8/mdk4.1
	gzip -f $(DESTDIR)$(MANDIR)/man8/mdk4.1

.PHONY : clean
clean:
	$(MAKE) -C $(SRC) clean

test:
	$(MAKE) -C $(SRC) test

distclean: clean

=== debian/changelog ===
mdk4 (4.1+git20190904-1) unstable; urgency=medium

  * New upstream version 4.1+git20190904
  * Bump Standards-Version to 4.4.0
  * d/p/fix-w-b-option.patch: Remove patch, applied upstream

  [ Helmut Grohne ]
  * Fix FTCBFS: Supply PKG_CONFIG for all make targets. (Closes: #930913)

 -- Samuel Henrique <samueloph@debian.org>  Wed, 04 Sep 2019 21:30:49 +0100

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
                libnl-genl-3-dev,
                libpcap-dev,
                pkg-config
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Homepage: https://github.com/aircrack-ng/mdk4
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/mdk4
 Vcs-Git: https://salsa.debian.org/pkg-security-team/mdk4.git

## mdk4 4.1+git20200420

=== Makefile ===
MDK_ROOT = ..
include $(MDK_ROOT)/common.mak

CFLAGS		+= -g -O3 -Wall -Wextra 
LINKFLAGS	= -lpthread -lpcap $(LDFLAGS)

SBINDIR		= $(PREFIX)/sbin
MANDIR		= $(PREFIX)/share/man

OSD		= osdep
LIBS		+= -lm -L$(OSD) -l$(OSD)
LIBOSD		= $(OSD)/lib$(OSD).so

OBJS		= debug.o helpers.o mac_addr.o linkedlist.o greylist.o dumpfile.o packet.o brute.o
OBJS_OSD	= osdep.o channelhopper.o ghosting.o fragmenting.o

ATTACKS		= attacks
OBJ_ATT		= $(shell ls attacks/*.h | sed s/"\.h"/"\.o"/g)

all: osd mdk4 $(OBJ_ATT) att

att:
	$(MAKE) -C $(ATTACKS)

osd:
	$(MAKE) -C $(OSD)

$(LIBOSD) $(OSD)/libosdep.a:
	$(MAKE) -C $(OSD)

$(OBJ_ATT):
	$(MAKE) -C $(ATTACKS)

mdk4: mdk4.c $(OSD)/libosdep.a $(OBJS) $(OBJS_OSD) $(OBJ_ATT)
	$(MAKE) -C $(ATTACKS)
	$(CC) $(CFLAGS) $(CPPFLAGS) $(^) -o $(@) $(LIBS) $(LINKFLAGS)

test: test.c $(OBJS)
	$(CC) $(CFLAGS) $(CPPFLAGS) $(^) -o $(@) $(LINKFLAGS)
	mv $(@) ..

install: mdk4
	install -D -m 0755 $^ $(SBINDIR)/$^
	$(MAKE) -C $(ATTACKS) install
	$(MAKE) -C $(OSD) install

.PHONY : clean
clean:
	rm -f mdk4
	rm -f $(OBJS) $(OBJS_OSD)
	rm -f ../test *.o
	$(MAKE) -C $(OSD) clean
	$(MAKE) -C $(ATTACKS) clean

distclean: clean

=== attacks/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
-CFLAGS		= -g -O3 -Wall -Wextra
-LINKFLAGS	= -lpthread
+CFLAGS		+= -g -O3 -Wall -Wextra
+LINKFLAGS	= -lpthread $(LDFLAGS)
 
 OBJS		= $(shell ls *.h | sed s/"\.h"/"\.o"/g)

=== debian/changelog ===
mdk4 (4.1+git20200420-2) unstable; urgency=medium

  * Bump DH to 13
  * d/p/gcc10_ftbfs.patch: New patch to fix GCC10 FTBFS by
    setting '-fcommon' (closes: #957524)

 -- Samuel Henrique <samueloph@debian.org>  Sat, 25 Jul 2020 12:35:56 +0100

mdk4 (4.1+git20200420-1) unstable; urgency=medium

  * New upstream version 4.1+git20200420
  * Bump Standards Version to 4.5.0
  * d/control: Add Rules-Requires-Root: no
  * Configure git-buildpackage for Debian
  * Add salsa-ci.yml

  [ Debian Janitor ]
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Update standards version to 4.4.1, no changes needed.

 -- Samuel Henrique <samueloph@debian.org>  Mon, 20 Apr 2020 21:07:56 +0100

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,13 @@
 Priority: optional
 Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
 Uploaders: Samuel Henrique <samueloph@debian.org>
-Build-Depends: debhelper (>= 12),
+Build-Depends: debhelper-compat (= 13),
                libnl-3-dev,
                libnl-genl-3-dev,
                libpcap-dev,
                pkg-config
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Homepage: https://github.com/aircrack-ng/mdk4
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/mdk4
 Vcs-Git: https://salsa.debian.org/pkg-security-team/mdk4.git

## mdk4 4.2

=== Makefile ===
DESTDIR		= 
PREFIX		= /usr/local
SBINDIR		= $(PREFIX)/sbin
MANDIR		= $(PREFIX)/share/man

SRC		= src


all: clean
	$(MAKE) -C $(SRC)

install: all
	PREFIX=$(DESTDIR)$(PREFIX)
	$(MAKE) -C $(SRC) install
	install -D -m 0644 man/mdk4.2 $(DESTDIR)$(MANDIR)/man8/mdk4.2
	gzip -f $(DESTDIR)$(MANDIR)/man8/mdk4.2

.PHONY : clean
clean:
	$(MAKE) -C $(SRC) clean

test:
	$(MAKE) -C $(SRC) test

distclean: clean

=== src/Makefile ===
MDK_ROOT = ..
include $(MDK_ROOT)/common.mak

# TODO: Remove '-fcommon' from CFLAGS and address issues, reference:
# https://gcc.gnu.org/gcc-10/porting_to.html#common
CFLAGS		+= -g -O3 -Wall -Wextra -fcommon
LINKFLAGS	= -lpthread -lpcap $(LDFLAGS)

SBINDIR		= $(PREFIX)/sbin
MANDIR		= $(PREFIX)/share/man

OSD		= osdep
LIBS		+= -lm -L$(OSD) -l$(OSD)
LIBOSD		= $(OSD)/lib$(OSD).so

OBJS		= debug.o helpers.o mac_addr.o linkedlist.o greylist.o dumpfile.o packet.o brute.o
OBJS_OSD	= osdep.o channelhopper.o ghosting.o fragmenting.o

ATTACKS		= attacks
OBJ_ATT		= $(shell ls attacks/*.h | sed s/"\.h"/"\.o"/g)

all: osd mdk4 $(OBJ_ATT) att

att:
	$(MAKE) -C $(ATTACKS)

osd:
	$(MAKE) -C $(OSD)

$(LIBOSD) $(OSD)/libosdep.a:
	$(MAKE) -C $(OSD)

$(OBJ_ATT):
	$(MAKE) -C $(ATTACKS)

mdk4: mdk4.c $(OSD)/libosdep.a $(OBJS) $(OBJS_OSD) $(OBJ_ATT)
	$(MAKE) -C $(ATTACKS)
	$(CC) $(CFLAGS) $(CPPFLAGS) $(^) -o $(@) $(LIBS) $(LINKFLAGS)

test: test.c $(OBJS)
	$(CC) $(CFLAGS) $(CPPFLAGS) $(^) -o $(@) $(LINKFLAGS)
	mv $(@) ..

install: mdk4
	install -D -m 0755 $^ $(SBINDIR)/$^
	$(MAKE) -C $(ATTACKS) install
	$(MAKE) -C $(OSD) install
	mkdir -p /usr/local/src/mdk4
	cp -r pocs /usr/local/src/mdk4

.PHONY : clean
clean:
	rm -f mdk4
	rm -f $(OBJS) $(OBJS_OSD)
	rm -f ../test *.o
	$(MAKE) -C $(OSD) clean
	$(MAKE) -C $(ATTACKS) clean

distclean: clean

=== src/osdep/Makefile ===
MDK_ROOT	= ../..
include $(MDK_ROOT)/common.mak

RTAP		= radiotap

LIB		= libosdep.a 
CFLAGS		+= $(PIC) -I.. $(LIBAIRPCAP)

OBJS_COMMON	= network.o file.o
OBJS		= osdep.o $(OBJS_COMMON)

#AIRPCAP_DIR	= airpcap
OBJS_APCAP	= airpcap.o

OBJS_OBSD	= $(OBJS) openbsd.o openbsd_tap.o
OBJS_NBSD	= $(OBJS) netbsd.o netbsd_tap.o
OBJS_FBSD	= $(OBJS) freebsd.o freebsd_tap.o
OBJS_LINUX	= $(OBJS) linux.o linux_tap.o radiotap/radiotap.o common.o
OBJS_DUMMY	= $(OBJS) dummy.o dummy_tap.o
OBJS_CYGWIN	= $(OBJS) cygwin.o cygwin_tap.o radiotap/radiotap.o
OBJS_DARWIN = $(OBJS) darwin.o darwin_tap.o radiotap/radiotap.o

# XXX make it a DLL, without polluting cygwin.c
ifeq ($(subst TRUE,true,$(filter TRUE true,$(airpcap) $(AIRPCAP))),true)
	OBJS_CYGWIN    += $(OBJS_APCAP)
	DOPCAP		= $(AR) x $(AC_ROOT)/../developers/Airpcap_Devpack/lib/libairpcap.a
else
	DOPCAP		=
endif

all:
	@echo Building for $(OSNAME)
	@$(MAKE) .os.$(OSNAME)

.os.dummy: $(OBJS_DUMMY)
	$(AR) cru $(LIB) $(OBJS_DUMMY)
	$(RANLIB) $(LIB)
	touch $(@)

.os.FreeBSD: $(OBJS_FBSD)
	$(AR) cru $(LIB) $(OBJS_FBSD)
	$(RANLIB) $(LIB)
	touch $(@)

.os.GNU-kFreeBSD: $(OBJS_FBSD)
	$(AR) cru $(LIB) $(OBJS_FBSD)
	$(RANLIB) $(LIB)
	touch $(@)

.os.OpenBSD: $(OBJS_OBSD)
	$(AR) cru $(LIB) $(OBJS_OBSD)
	$(RANLIB) $(LIB)
	touch $(@)

.os.NetBSD: $(OBJS_NBSD)
	$(AR) cru $(LIB) $(OBJS_NBSD)
	$(RANLIB) $(LIB)
	touch $(@)

.os.Linux: $(OBJS_LINUX)
	$(AR) cru $(LIB) $(OBJS_LINUX)
	$(RANLIB) $(LIB)
	touch $(@)

.os.cygwin: $(OBJS_CYGWIN) 
	$(DOPCAP)
	$(AR) cru $(LIB) *.o radiotap/radiotap.o
	$(RANLIB) $(LIB) 
	touch $(@)

.os.Darwin: $(OBJS_DARWIN) 
	$(DOPCAP)
	$(AR) cru $(LIB) $(OBJS_DARWIN)
	$(RANLIB) $(LIB) 
	touch $(@)

.os.%: .os.dummy
	@echo "Your platform is unsupported by osdep, dummy code compiled."
	touch $(@)

install: all

uninstall:

clean: 
	$(MAKE) -C $(RTAP) clean
	rm -f $(LIB) *.o .os.*

=== src/osdep/radiotap/Makefile ===
all:

install:

uninstall:

clean:
	rm -f *.o

=== debian/changelog ===
mdk4 (4.2-5) unstable; urgency=medium

  * Team upload.
  * Add patch to fix FTBFS with gcc-14 (Closes: #1081054).
  * Update copyrights of the debian/* stanza.
  * Bump Standards-Version to 4.7.0.
  * Add missing "Team upload." to the previous changelog entry.

 -- Sven Geuer <sge@debian.org>  Fri, 04 Oct 2024 16:24:21 +0200

mdk4 (4.2-4) unstable; urgency=medium

  * Team upload.
  * Import upstream patch "fix x mode bug"
  * Add patch to fix implicit-function-declaration (Closes: #1068037)
  * Build-Depends: pkg-config => pkgconf

 -- Arnaud Rebillout <arnaudr@kali.org>  Mon, 22 Apr 2024 08:48:30 +0700

mdk4 (4.2-3) unstable; urgency=medium

  * Bump Standards-Version to 4.6.0
  * d/p/makefile_osdep_parallel_build_fix: New patch from upstream to fix
    parallel builds. Thanks to Adrian Bunk for submitting the fix.

 -- Samuel Henrique <samueloph@debian.org>  Sun, 12 Sep 2021 00:07:26 +0100

mdk4 (4.2-2) unstable; urgency=medium

  * d/docs: Ship example files and README.md (closes: #993165)

 -- Samuel Henrique <samueloph@debian.org>  Sat, 28 Aug 2021 14:28:22 +0100

mdk4 (4.2-1) unstable; urgency=medium

  * New upstream version 4.2
  * d/copyright: Update main license to GPL-3+
  * d/p/gcc10_ftbfs.patch: Drop upstreamed patch

 -- Samuel Henrique <samueloph@debian.org>  Sat, 14 Aug 2021 18:45:24 +0100

=== debian/control ===
--- 
+++ 
@@ -7,8 +7,8 @@
                libnl-3-dev,
                libnl-genl-3-dev,
                libpcap-dev,
-               pkg-config
-Standards-Version: 4.5.0
+               pkgconf,
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://github.com/aircrack-ng/mdk4
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/mdk4

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,7 @@
 #!/usr/bin/make -f
+
+-include /usr/share/dpkg/buildtools.mk
+export PKG_CONFIG ?= pkg-config
 
 #export DH_VERBOSE=1
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%mdk4-$1.tar.gz%" \
   https://github.com/aircrack-ng/mdk4/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
